searchData={"items":[{"type":"module","title":"NOAA.Observations","doc":"Fetches weather observations for a US state/territory code.","ref":"NOAA.Observations.html"},{"type":"function","title":"NOAA.Observations.fetch/1","doc":"Fetches weather observations for a US state/territory `code`.\n\nReturns either tuple `{:ok, [observation]}` or tuple `{:error, text}`.","ref":"NOAA.Observations.html#fetch/1"},{"type":"function","title":"Examples - NOAA.Observations.fetch/1","doc":"iex> alias NOAA.Observations\n    iex> {:ok, observations} = Observations.fetch(\"vt\")\n    iex> Enum.all?(observations, &is_map/1) and length(observations) > 0\n    true","ref":"NOAA.Observations.html#fetch/1-examples"},{"type":"module","title":"NOAA.Observations.CLI","doc":"Parses the command line and prints a table of weather observations\nfrom the NOAA Weather Service.\n\n###","ref":"NOAA.Observations.CLI.html"},{"type":"module","title":"Exercise in the book [Programming Elixir](https://pragprog.com/book/elixir16/programming-elixir-1-6) by Dave Thomas. - NOAA.Observations.CLI","doc":"","ref":"NOAA.Observations.CLI.html#module-exercise-in-the-book-programming-elixir-https-pragprog-com-book-elixir16-programming-elixir-1-6-by-dave-thomas"},{"type":"function","title":"NOAA.Observations.CLI.main/1","doc":"Parses the command line and prints a table of weather observations\nfrom the NOAA Weather Service.\n\n`argv` can be \"-h\" or \"--help\", which prints info on the command's\nusage and syntax. Otherwise it is a US state/territory code\n(case-insensitive) and optionally the number of observations\nto format (the first _n_ ones).\nTo format the last _n_ observations, specify switch `--last`.\n\nTo ring the bell, specify switch `--bell`.\nTo choose a table style, specify switch `--table-style`.","ref":"NOAA.Observations.CLI.html#main/1"},{"type":"function","title":"Parameters - NOAA.Observations.CLI.main/1","doc":"- `argv` - command line arguments (list)","ref":"NOAA.Observations.CLI.html#main/1-parameters"},{"type":"function","title":"Switches - NOAA.Observations.CLI.main/1","doc":"- `-h` or `--help`        - for help\n  - `-b` or `--bell`        - to ring the bell\n  - `-l` or `--last`        - to format the last _n_ observations\n  - `-t` or `--table-style` - to choose a table style","ref":"NOAA.Observations.CLI.html#main/1-switches"},{"type":"function","title":"Table styles - NOAA.Observations.CLI.main/1","doc":"- `bare`                  - no colors\n  - `barish`                - like bare but colored\n  - `cyan`                  - cyan background\n  - `cyan-alt`              - cyan header, alternating row colors\n  - `cyan-border`           - light cyan border\n  - `cyan-mult`             - cyan header, 3 repeating row colors\n  - `dark`                  - dark colors\n  - `dark-alt`              - dark colors, alternating row colors\n  - `dark-mult`             - dark colors, 3 repeating row colors\n  - `dashed`                - no colors\n  - `dotted`                - slightly colored\n  - `dotted-alt`            - slightly colored, alternating row colors\n  - `dotted-mult`           - slightly colored, 3 repeating row colors\n  - `game`                  - game board\n  - `green`                 - green background\n  - `green-alt`             - green header, alternating row colors\n  - `green-border`          - light green border\n  - `green-border-padded`   - light green border with extra padding\n  - `green-border-unpadded` - light green border without padding\n  - `green-mult`            - green header, 3 repeating row colors\n  - `green-padded`          - like green but with extra padding\n  - `green-unpadded`        - like green but without padding\n  - `light`                 - light colors\n  - `light-alt`             - light colors, alternating row colors\n  - `light-mult`            - light colors, 3 repeating row colors\n  - `medium`                - medium colors\n  - `medium-alt`            - medium colors, alternating row colors\n  - `medium-mult`           - medium colors, 3 repeating row colors\n  - `mixed`                 - fillers revealed\n  - `plain`                 - slightly colored\n  - `pretty`                - multicolored\n  - `pretty-alt`            - multicolored, alternating row colors\n  - `pretty-mult`           - multicolored, 3 repeating row colors\n  - `test`                  - no colors\n  - `yellow`                - light yellow background\n  - `yellow-border`         - light yellow border","ref":"NOAA.Observations.CLI.html#main/1-table-styles"},{"type":"module","title":"NOAA.Observations.Help","doc":"Prints info on the escript command's usage and syntax.","ref":"NOAA.Observations.Help.html"},{"type":"function","title":"NOAA.Observations.Help.show_help/0","doc":"Prints info on the escript command's usage and syntax.","ref":"NOAA.Observations.Help.html#show_help/0"},{"type":"module","title":"NOAA.Observations.Log","doc":"","ref":"NOAA.Observations.Log.html"},{"type":"function","title":"NOAA.Observations.Log.error/2","doc":"","ref":"NOAA.Observations.Log.html#error/2"},{"type":"function","title":"NOAA.Observations.Log.info/2","doc":"","ref":"NOAA.Observations.Log.html#info/2"},{"type":"module","title":"NOAA.Observations.Message","doc":"","ref":"NOAA.Observations.Message.html"},{"type":"function","title":"NOAA.Observations.Message.error/1","doc":"","ref":"NOAA.Observations.Message.html#error/1"},{"type":"function","title":"NOAA.Observations.Message.fetching_error/2","doc":"","ref":"NOAA.Observations.Message.html#fetching_error/2"},{"type":"function","title":"NOAA.Observations.Message.status/1","doc":"","ref":"NOAA.Observations.Message.html#status/1"},{"type":"function","title":"NOAA.Observations.Message.writing_table/1","doc":"","ref":"NOAA.Observations.Message.html#writing_table/1"},{"type":"module","title":"NOAA.Observations.State","doc":"Fetches the stations for a US state/territory code.","ref":"NOAA.Observations.State.html"},{"type":"function","title":"NOAA.Observations.State.stations/2","doc":"Fetches the stations for a US state/territory `code`.\n\nReturns a tuple of either `{:ok, [station]}` or `{:error, text}`.","ref":"NOAA.Observations.State.html#stations/2"},{"type":"function","title":"Parameters - NOAA.Observations.State.stations/2","doc":"- `code`          - US state/territory code\n  - `url_templates` - URL templates","ref":"NOAA.Observations.State.html#stations/2-parameters"},{"type":"function","title":"Examples - NOAA.Observations.State.stations/2","doc":"iex> alias NOAA.Observations.State\n    iex> url_templates = [\n    ...>   state:\n    ...>     \"https://w1.weather.gov/xml/current_obs/seek.php?state=\" <>\n    ...>       \"<%=state%>&Find=Find\"\n    ...> ]\n    iex> {:ok, stations} = State.stations(\"vt\", url_templates)\n    iex> %{\"KFSO\" => name} = Map.new(stations)\n    iex> name\n    \"Franklin County State Airport\"\n\n    iex> alias NOAA.Observations.State\n    iex> url_templates = [\n    ...>   state:\n    ...>     \"http://w1.weather.gov/xml/current_obs/seek.php?state=\" <>\n    ...>       \"<%=state%>&Find=Find\"\n    ...> ]\n    iex> {:error, text} = State.stations(\"vt\", url_templates)\n    iex> text\n    \"status code 301 ⇒ Moved Permanently\"\n\n    iex> alias NOAA.Observations.State\n    iex> url_templates = [\n    ...>   state:\n    ...>     \"https://www.weather.gov/xml/current_obs/seek.php?state=\" <>\n    ...>       \"<%=state%>&Find=Find\"\n    ...> ]\n    iex> {:error, text} = State.stations(\"vt\", url_templates)\n    iex> text\n    \"status code 302 ⇒ Found\"\n\n    iex> alias NOAA.Observations.State\n    iex> url_templates = [\n    ...>   state:\n    ...>     \"https://w1.weather.gov/xml/past_obs/seek.php?state=\" <>\n    ...>       \"<%=state%>&Find=Find\"\n    ...> ]\n    iex> {:error, text} = State.stations(\"vt\", url_templates)\n    iex> text\n    \"status code 404 ⇒ Not Found\"\n\n    iex> alias NOAA.Observations.State\n    iex> url_templates = [\n    ...>   state:\n    ...>     \"htp://w1.weather.gov/xml/current_obs/seek.php?state=\" <>\n    ...>       \"<%=state%>&Find=Find\"\n    ...> ]\n    iex> {:error, text} = State.stations(\"vt\", url_templates)\n    iex> text\n    \"reason => :nxdomain\"\n\n    iex> alias NOAA.Observations.State\n    iex> url_templates = [state: \"http://localhost:1\"]\n    iex> {:error, text} = State.stations(\"vt\", url_templates)\n    iex> text\n    \"reason => :econnrefused\"","ref":"NOAA.Observations.State.html#stations/2-examples"},{"type":"type","title":"NOAA.Observations.State.code/0","doc":"US state/territory code","ref":"NOAA.Observations.State.html#t:code/0"},{"type":"module","title":"NOAA.Observations.Station","doc":"Fetches the latest observation for a given NOAA station.","ref":"NOAA.Observations.Station.html"},{"type":"function","title":"NOAA.Observations.Station.observation/3","doc":"Fetches the latest observation for a given NOAA `station`.\n\nReturns either tuple `{:ok, observation}` or tuple `{:error, text}`.","ref":"NOAA.Observations.Station.html#observation/3"},{"type":"function","title":"Parameters - NOAA.Observations.Station.observation/3","doc":"- `{id, name}`    - NOAA station\n  - `url_templates` - URL templates","ref":"NOAA.Observations.Station.html#observation/3-parameters"},{"type":"function","title":"Examples - NOAA.Observations.Station.observation/3","doc":"iex> alias NOAA.Observations.Station\n    iex> url_templates = [\n    ...>   station:\n    ...>     \"https://w1.weather.gov/xml/current_obs/display.php?stid=\" <>\n    ...>       \"<%=station%>\"\n    ...> ]\n    iex> {:ok, observation} =\n    ...>   Station.observation({\"KFSO\", \"KFSO name\"}, \"vt\", url_templates)\n    iex> is_map(observation) and\n    ...> is_binary(observation[\"temp_c\"]) and\n    ...> is_binary(observation[\"wind_mph\"])\n    true\n\n    iex> alias NOAA.Observations.Station\n    iex> url_templates = [\n    ...>   station:\n    ...>     \"htp://w1.weather.gov/xml/current_obs/display.php?stid=\" <>\n    ...>       \"<%=station%>\"\n    ...> ]\n    iex> {:error, text} =\n    ...>   Station.observation({\"KFSO\", \"KFSO name\"}, \"vt\", url_templates)\n    iex> text\n    \"reason => :nxdomain\"\n\n    iex> alias NOAA.Observations.Station\n    iex> url_templates = [\n    ...>   station:\n    ...>     \"https://w1.weather.gov/xml/past_obs/display.php?stid=\" <>\n    ...>       \"<%=station%>\"\n    ...> ]\n    iex> {:error, text} =\n    ...>   Station.observation({\"KFSO\", \"KFSO name\"}, \"vt\", url_templates)\n    iex> text\n    \"status code 404 ⇒ Not Found\"","ref":"NOAA.Observations.Station.html#observation/3-examples"},{"type":"type","title":"NOAA.Observations.Station.id/0","doc":"Station ID","ref":"NOAA.Observations.Station.html#t:id/0"},{"type":"type","title":"NOAA.Observations.Station.name/0","doc":"Station name","ref":"NOAA.Observations.Station.html#t:name/0"},{"type":"type","title":"NOAA.Observations.Station.observation/0","doc":"NOAA weather observation","ref":"NOAA.Observations.Station.html#t:observation/0"},{"type":"type","title":"NOAA.Observations.Station.t/0","doc":"NOAA station","ref":"NOAA.Observations.Station.html#t:t/0"},{"type":"module","title":"NOAA.Observations.URLTemplates","doc":"Returns a URL based on URL templates and a station ID or state code.","ref":"NOAA.Observations.URLTemplates.html"},{"type":"function","title":"NOAA.Observations.URLTemplates.url/2","doc":"Returns a URL based on `url_templates` and a station `id` or state `code`.","ref":"NOAA.Observations.URLTemplates.html#url/2"},{"type":"function","title":"Parameters - NOAA.Observations.URLTemplates.url/2","doc":"- `url_templates` - keyword of EEx strings\n  - `options`       - [station: `id`] or [state: `code`]","ref":"NOAA.Observations.URLTemplates.html#url/2-parameters"},{"type":"function","title":"Examples - NOAA.Observations.URLTemplates.url/2","doc":"iex> alias NOAA.Observations.URLTemplates\n    iex> url_templates = [\n    ...>  state: \"w1.weather.gov/seek.php?state=<%=state%>&Find=Find\",\n    ...>  station: \"w1.weather.gov/display.php?stid=<%=station%>\"\n    ...> ]\n    iex> {URLTemplates.url(url_templates, state: \"vt\"),\n    ...>  URLTemplates.url(url_templates, station: \"KBTV\")}\n    {\"w1.weather.gov/seek.php?state=vt&Find=Find\",\n     \"w1.weather.gov/display.php?stid=KBTV\"}\n\n    iex> alias NOAA.Observations.URLTemplates\n    iex> url_templates = [\n    ...>   state: \"weather.gc.ca/forecast/canada/index_e.html?id=<%=state%>\"\n    ...> ]\n    iex> URLTemplates.url(url_templates, state: \"qc\")\n    \"weather.gc.ca/forecast/canada/index_e.html?id=qc\"","ref":"NOAA.Observations.URLTemplates.html#url/2-examples"}],"content_type":"text/markdown"}